#! /bin/sh

# -------------------------------------------------------------------------- #
# Copyright 2002-2009, Distributed Systems Architecture Group, Universidad   #
# Complutense de Madrid (dsa-research.org)                                   #
#                                                                            #
# Licensed under the Apache License, Version 2.0 (the "License"); you may    #
# not use this file except in compliance with the License. You may obtain    #
# a copy of the License at                                                   #
#                                                                            #
# http://www.apache.org/licenses/LICENSE-2.0                                 #
#                                                                            #
# Unless required by applicable law or agreed to in writing, software        #
# distributed under the License is distributed on an "AS IS" BASIS,          #
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.   #
# See the License for the specific language governing permissions and        #
# limitations under the License.                                             #
#--------------------------------------------------------------------------- #

if [ -z "$ONE_LOCATION" ]; then 
    ONE_PID=/var/run/one/oned.pid
    ONE_SCHEDPID=/var/run/one/sched.pid
    ONE_CONF=/etc/one/oned.conf

    ONED=/usr/bin/oned
    ONE_SCHEDULER=/usr/bin/mm_sched

    LOCK_FILE=/var/lock/one
else
    ONE_PID=$ONE_LOCATION/var/oned.pid
    ONE_SCHEDPID=$ONE_LOCATION/var/sched.pid
    ONE_CONF=$ONE_LOCATION/etc/oned.conf

    ONED=$ONE_LOCATION/bin/oned
    ONE_SCHEDULER=$ONE_LOCATION/bin/mm_sched
    
    LOCK_FILE=$ONE_LOCATION/var/.lock
fi 

setup()
{
	PORT=`cat $ONE_CONF | grep ^PORT= | cut -d= -f2`

	if [ $? -ne 0 ]; then
		echo "Can not find PORT in $ONE_CONF."
		exit 1
	fi
	
	if [ -f $LOCK_FILE ]; then
		if [ -f  $ONE_PID ]; then
			ONEPID=`cat $ONE_PID`
			ps $ONEPID > /dev/null 2>&1
			if [ $? -eq 0 ]; then
				echo "ONE is still running (PID:$ONEPID). Please try 'one stop' first."
				exit 1 
			fi
		fi
		if [ -f  $ONE_SCHEDPID ]; then
			ONESCHEDPID=`cat $ONE_SCHEDPID`
			ps $ONESCHEDPID > /dev/null 2>&1
			if [ $? -eq 0 ]; then
				echo "The scheduler is still running (PID:$ONEPID). Please try 'one stop' first."
				exit 1
			fi
		fi
		echo "Stale .lock detected. Erasing it."
		rm $LOCK_FILE
	fi
}

start()
{
	if [ ! -x "$ONED" ]; then
		echo "Can not find $ONED."
		exit 1		
	fi

	if [ ! -x "$ONE_SCHEDULER" ]; then
		echo "Can not find $ONE_SCHEDULER."
		exit 1		
	fi
		
	# Start the one daemon
	$ONED -f 2>&1 & 
	
	LASTRC=$?
	LASTPID=$!

	if [ $LASTRC -ne 0 ]; then
		echo "Error executing $ONED"
		exit 1			
	else
		echo $LASTPID > $ONE_PID
	fi
	
	sleep 1
	ps $LASTPID > /dev/null 2>&1
	
	if [ $? -ne 0 ]; then
		echo "Error executing $ONED."
		exit 1
	fi
	
	# Start the scheduler
	$ONE_SCHEDULER -p $PORT &

	LASTRC=$?
	LASTPID=$!

	if [ $LASTRC -ne 0 ]; then
		echo "Error executing $ONE_SCHEDULER"
		exit 1			
	else
		echo $LASTPID > $ONE_SCHEDPID
	fi
	
	echo "oned and scheduler started"
}

#
# Function that stops the daemon/service
#
stop()
{
	if [ ! -f $ONE_PID ]; then
		echo "Couldn't find oned process pid."
		exit 1
	fi

	if [ ! -f $ONE_SCHEDPID ]; then
		echo "Couldn't find scheduler process pid."
		exit 1
	fi

	# Kill the one daemon

	kill `cat $ONE_PID` > /dev/null 2>&1

	# Kill the scheduler
	
	kill `cat $ONE_SCHEDPID` > /dev/null 2>&1

	# Remove pid files

	rm -f $ONE_PID > /dev/null 2>&1
	rm -f $ONE_SCHEDPID > /dev/null 2>&1

	echo "oned and scheduler stopped"
}


case "$1" in
  start)
	setup
	start
	;;
  stop)
	stop
	;;
  *)
	echo "Usage: one {start|stop}" >&2
	exit 3
	;;
esac
